﻿Public Class Form1
    ' The numeric code for Ctrl.
    Private Const KeyCtrl As Integer = 8

    ' A drag entered. List available formats.
    Private Sub lblDrop_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lblDrop.DragEnter
        lstFormats.Items.Clear()
        For Each format As String In e.Data.GetFormats()
            lstFormats.Items.Add(format)
        Next format

        ' Allow text or file drop.
        If e.Data.GetDataPresent(DataFormats.Text) OrElse
           e.Data.GetDataPresent(DataFormats.FileDrop) _
        Then
            ' Only allow the Copy operation.
            e.Effect = DragDropEffects.Copy Or DragDropEffects.Move
        End If
    End Sub

    ' Accept dropped data.
    Private Sub lblDrop_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lblDrop.DragDrop
        ' See if the data is text.
        If e.Data.GetDataPresent(DataFormats.Text) Then
            ' Get the dropped data.
            lblDrop.Text = e.Data.GetData(DataFormats.Text).ToString()

            ' See if the Ctrl key is pressed.
            If (e.KeyState And KeyCtrl) <> 0 Then
                ' The Ctrl key is pressed. We did a Copy.
                e.Effect = DragDropEffects.Copy
            Else
                ' The Ctrl key is not pressed. We did a Move.
                e.Effect = DragDropEffects.Move
            End If
        ElseIf e.Data.GetDataPresent(DataFormats.FileDrop) Then
            ' Display the file names.
            lstFiles.Items.Clear()

            ' Get the list of files dropped.
            Dim filenames() As String = DirectCast(e.Data.GetData(DataFormats.FileDrop), String())
            For Each filename As String In filenames
                lstFiles.Items.Add(filename)
            Next filename

            ' We did a Copy.
            e.Effect = DragDropEffects.Copy
        End If
    End Sub

    ' Provide feedback. Allow Copy if Ctrl is pressed.
    ' Otherwise allow Move.
    Private Sub lblDrop_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lblDrop.DragOver
        ' See if the Ctrl key is pressed.
        If (e.KeyState And KeyCtrl) <> 0 Then
            ' The Ctrl key is pressed. Allow Copy.
            e.Effect = DragDropEffects.Copy
        Else
            ' The Ctrl key is not pressed. Allow Move.
            e.Effect = DragDropEffects.Move
        End If
    End Sub

    ' Clear the format list.
    Private Sub lblDrop_DragLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblDrop.DragLeave
        lstFormats.Items.Clear()
    End Sub
End Class
